#line 1 "C:/Users/Amaury LAURENT/Dropbox/Microcontroleurs/Amaury/Virtual COM Port/VCP_Example.c"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic32/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/amaury laurent/dropbox/microcontroleurs/amaury/virtual com port/ihm.h"
void IHM_Init (void);
void IHM_Write_Line (char * txt);
void IHM_ClearSreen (void);
#line 27 "C:/Users/Amaury LAURENT/Dropbox/Microcontroleurs/Amaury/Virtual COM Port/VCP_Example.c"
char buffer[64];
char txt_line[64] = "";
char short_value[20] = "";
uint32_t baudrate = 19200;
uint8_t stop_bit = 0;
uint8_t parity = 0;
uint8_t data_bits = 8;
void ConfigUART ();


typedef struct{
 uint32_t dwDTERate;
 uint8_t bCharFormat;


 uint8_t bParityType;




 uint8_t bDataBits;

}TUSBCDCLineCoding;

TUSBCDCLineCoding * COM_Conf;

void USB1Interrupt() iv IVT_USB_1 ilevel 7 ics ICS_SRS{

 USBDev_IntHandler();
}

void UART1_Isr() iv IVT_UART_1 ilevel 6 ics ICS_SOFT {
 int j;

 j = 0;

 while (UART1_Data_Ready()) {
 *(buffer+j++) = UART1_Read();
 }

 USBDev_CDCSendData(buffer, j);

 U1RXIF_bit = 0;
}

void USBDev_CDCParamsChanged(){
 ConfigUART ();
}

extern const uint8_t _USB_CDC_BULK_EP_IN;
extern const uint8_t _USB_CDC_BULK_EP_OUT;

void USBDev_CDCDataReceived(uint16_t size){
 int i;

 i = 0;

 USBDev_CDCSetReceiveBuffer(buffer);

 for (i=0; i<size; i++) UART1_Write(*(buffer+i));

}

void ConfigUART () {
 baudrate = COM_Conf->dwDTERate;
#line 156 "C:/Users/Amaury LAURENT/Dropbox/Microcontroleurs/Amaury/Virtual COM Port/VCP_Example.c"
 UART1_Init(baudrate);
}

void main() {
 uint32_t old_baudrate = 0;
 trisd.f11 = 0;


 latd.f11 = 0;
 Delay_ms(1500);
 latd.f11 = 1;

 AD1PCFG = 0xFFFF;


 USBDev_CDCInit();


 USBDev_Init();


 USBIE_bit = 1;
 IPC11bits.USBIP = 7;
 U1IP0_bit = 0;
 U1IP1_bit = 1;
 U1IP2_bit = 1;
 U1RXIE_bit = 1;
 EnableInterrupts();


 while(USBDev_GetDeviceState() != _USB_DEV_STATE_CONFIGURED)
 ;


 USBDev_CDCSetReceiveBuffer(buffer);

 COM_Conf = USBDev_CDCGetLineCoding();

 IHM_Init ();
 ConfigUART ();


 while(1){
 if(old_baudrate != baudrate) {
 IHM_ClearSreen();
 baudrate = COM_Conf->dwDTERate;
 old_baudrate = baudrate;
 sprintf(txt_line , "Baudrate: %lu", baudrate);
 IHM_Write_Line (txt_line);
 }
 }

}
